#include "StdAfx.h"
#include "nsmplugin.h"
#include "commonservice.h"
#include "general_strings.h"

CNsmPlugin* CNsmPlugin::m_psingleton = NULL;
HINSTANCE CNsmPlugin::m_hInstance = NULL;

CNsmPlugin::CNsmPlugin(void)
{
	m_psingleton = this;

	m_pApiVer		= NULL_STRING;
	m_pModuleName	= NULL_STRING;
	m_pTitle		= NULL_STRING;
	m_pDescription	= NULL_STRING;
	m_pAuthor		= NULL_STRING;
	m_pCopyright	= NULL_STRING;
	m_pPluginVer	= NULL_STRING;
}

CNsmPlugin::~CNsmPlugin(void)
{
}

// vOC擾
int CNsmPlugin::GetPluginInfo( int nInfoNo, LPTSTR lpBuffer, int nSize )
{
	LPCSTR info = NULL;
	int len = 0;

	switch( nInfoNo ){
	case NMPI_APIVER:		info = m_pApiVer;		break;
	case NMPI_MODULENAME:	info = m_pModuleName;	break;
	case NMPI_TITLE:		info = m_pTitle;		break;
	case NMPI_DESCRIPTION:	info = m_pDescription;	break;
	case NMPI_AUTHOR:		info = m_pAuthor;		break;
	case NMPI_COPYRIGHT:	info = m_pCopyright;	break;
	case NMPI_PLUGINVER:	info = m_pPluginVer;	break;
	}

	if( info != NULL ){
		lstrcpyn(lpBuffer, info, nSize);
		len = lstrlen(lpBuffer) + 1;
	}

	return len;
}

// 
int CNsmPlugin::Initialize( PNsmPluginInitInfo lpNsmInitInfo )
{
	NSM_SERVICE.SetInitInfo(lpNsmInitInfo);
	NSM_SERVICE.HookEvent(NME_SYSTEM_MODULESLOADED, HookSystemModulesLoaded);

	return OnInitialize();
}

int CNsmPlugin::OnInitialize()
{
	return NMP_ALLRIGHT;
}

// I
int CNsmPlugin::Terminate()
{
	OnTerminate();
	return NMP_ALLRIGHT;
}

void CNsmPlugin::OnTerminate()
{
}

// SW[ǂݍ݊
int CNsmPlugin::OnSystemModulesLoaded()
{
	return NMP_ALLRIGHT;
}

//*******************************************************************
// vOCK{֐
//*******************************************************************
int __stdcall GetPluginInfo( int nInfoNo, LPTSTR lpBuffer, int nSize )
{
	return CNsmPlugin::GetInstance().GetPluginInfo(nInfoNo, lpBuffer, nSize);
}

int __stdcall Initialize( PNsmPluginInitInfo lpNsmInitInfo )
{
	return CNsmPlugin::GetInstance().Initialize(lpNsmInitInfo);
}

int __stdcall Terminate()
{
	return CNsmPlugin::GetInstance().Terminate();
}
