#include "StdAfx.h"
#include <stdlib.h>
#include "optionsettings.h"

COptionSettings::COptionSettings(LPCTSTR in_pluginName)
{
	SetPluginName(in_pluginName);
}

COptionSettings::~COptionSettings(void)
{
}


//*******************************************************************
// ̑
//*******************************************************************
// nsmsgs/Plugins/{PluginName}/ ̃tpX𓾂
tstring COptionSettings::GetMyDir()
{
	TCHAR buf[MAX_PATH];
	LPTSTR pos;
	tstring path;

	GetModuleFileName(NULL, buf, MAX_PATH);
	pos = _tcsrchr(buf, _T('\\'));
	_ASSERT(pos != NULL);
	if( pos != NULL ){
		*pos = _T('\0');
		path = buf;
		path += _T("\\Plugins\\");
		path += m_pluginName;
		path += _T("\\");
	}
	return path;
}

void COptionSettings::SetPluginName(LPCTSTR in_pluginName)
{
	tstring iniPath;

	m_pluginName = in_pluginName;

	iniPath = GetMyDir();
	iniPath += in_pluginName;
	iniPath += _T(".ini");
	m_ini.SetIniFileName(iniPath.c_str());
}

HMODULE COptionSettings::LoadLibrary(LPCTSTR lpLibFileName)
{
	tstring path;

	path = GetMyDir();
	path += lpLibFileName;
	return ::LoadLibrary(path.c_str());
}

