/* NSM Plug-In Interface (for Visual C++ Compiler) */

#ifndef NSM_PLUGIN_H
#define NSM_PLUGIN_H

#define NSM_API_VERSION "0.2.3"

typedef DWORD HNsmHandle;

typedef HNsmHandle HNsmSEHandle;
typedef HNsmHandle HNsmCSFHandle;

typedef HNsmSEHandle HNsmService;
typedef HNsmSEHandle HNsmEvent;

typedef HNsmCSFHandle HNsmConnection;
typedef HNsmCSFHandle HNsmSession;
typedef HNsmCSFHandle HNsmFileSession;

// PluginInfo
enum PluginInfoType{
	NMPI_APIVER,			// API ̃o[W
	NMPI_MODULENAME,		// W[
	NMPI_TITLE,				// vOC
	NMPI_DESCRIPTION,		// ȒPȐ
	NMPI_AUTHOR,			// 
	NMPI_COPYRIGHT,			// 쌠\
	NMPI_PLUGINVER,			// vOC̃o[W
};

//@Xg̎
enum ContactListType{
	NMLK_FORWARDLIST,		// R^NgXg
	NMLK_REVERSELIST,		// ΌXg
	NMLK_ALLOWLIST,			// Xg
	NMLK_BLOCKLIST,			// ֎~Xg
};

// o
enum MemberInfoType{
	NMMI_ACCOUNT=1000,		// AJEg
	NMMI_NAME,				// \
	NMMI_STATUS,			// 
	NMMI_STATUSSTRING,		// Ԃ\
	NMMI_BUSYNESS,			// Z(0..100)
	NMMI_GROUPID,			// O[vID
	NMMI_HINT,				//
	NMMI_1007_IS_NOT_USED_,
	NMMI_TYPING,						
};

// O[v
enum GroupInfoType{
	NMGI_ID=1000,			// O[vʎq
	NMGI_NAME,				// \
	NMGI_EXPANDED,			// O[v̓WJ
};

// oݒtO
#define NMIF_INITLIST				2			// XglݒtO
#define NMIF_NOCHANGEEVENT			4			// OnInfoChange Cxg𔭐Ȃ

// RlNV
enum ConnectionInfoType{
	NMCI_USER_ACCOUNT=NMMI_ACCOUNT,
	NMCI_USER_NAME=NMMI_NAME,
	NMCI_USER_STATUS=NMMI_STATUS,
	NMCI_USER_STATUSSTRING=NMMI_STATUSSTRING,
	NMCI_USER_BUSYNESS=NMMI_BUSYNESS,
	NMCI_USER_MAILSTATUS=1007,					// ǃ[

	NMCI_PROTOCOL=2000,							// vgRiǂݏopj
	NMCI_CAPTION,								// LvV
	NMCI_STATUS,								// ڑ
};

// ZbV
enum SessionInfoType{
	NMSI_CAPTION=1000,		// LvV
	NMSI_STATUS,			// ڑ
	NMSI_CONNECTION,		// eRlNViǂݏopj
	NMSI_PROTOCOL,			// vgRiǂݏopj
};

// t@CZbV
enum FileSessionInfoType{
	NMFI_SESSION=1000,		// eZbViǂݏopj
	NMFI_PROTOCOL,			// vgRiǂݏopj
	NMFI_FILENAME,			// t@C
	NMFI_FILESIZE,			// t@CTCY
	NMFI_CURRENTSIZE,		// 擾/Mς݃t@CTCY
	NMFI_ISSENDER,			// Mǂ
	NMFI_STATUS,			// 
};

// t@CZbV
enum FileSessionStatus{
	NMFT_OPENNING,			// ڑ
	NMFT_INVITED,			// ҂ꏳ҂
	NMFT_INVITING,			// ҂҂
	NMFT_ACCEPTED,			// ^ꂽ
	NMFT_CANCELED,			// LZ^ꂽ
	NMFT_NEGOTIATING,		// ]
	NMFT_RECEIVING,			// M
	NMFT_SENDING,			// M
	NMFT_TRANSFER_SUCCESS,	// ]I
	NMFT_TRANSFER_FAILED,	// ]s
};

// ȍ
enum MemberStatus{
	NMST_OFFLINE,			// ItC
	NMST_ONLINE,			// IC
	NMST_BUSY,				// 荞ݒ
	NMST_IDLE,				// ACh
	NMST_BERIGHTBACK,		// ߂܂
	NMST_AWAY,				// ސȒ
	NMST_ONTHEPHONE,		// db
	NMST_OUTTOLUNCH,		// x
	NMST_HIDDEN,			// s
	NMST_CUSTOM=1000,		// JX^
};

// ڑ̏
enum ConnectionStatus{
	NMCS_DISCONNECTED,		// ؒf
	NMCS_CONNECTED,			// ڑ
	NMCS_CONNECTING,		// ڑ
	NMCS_DISCONNECTING,		// ؒf
};

// ̌^
enum TypeOfValue{
	NMIT_STRING,			// Ansi 
	NMIT_WIDESTRING,		// Unicode 
	NMIT_INTEGER,			// t32bitl
	NMIT_BOOL,				// ^Ul
};

// ʒmACR
enum NotifyIconType{
	NMNI_EXCLAMATION,		// x
	NMNI_STOP,				// G[
	NMNI_INFORMATION,		// 
	NMNI_QUESTION,			// ₢킹
	NMNI_MESSAGE,			// bZ[WM
	NMNI_MAIL,				// [M
	NMNI_FILE,				// t@CM
	NMNI_CONNECT,			// ڑ
	NMNI_DISCONNECT,		// ؒf
	NMNI_ONLINE,			// oIC
	NMNI_OFFLINE,			// oItC
	NMNI_BUSY,				// orW[
};

// 
#define NMFS_BOLD					2			// 
#define NMFS_ITALIC					4			// Α
#define NMFS_UNDERLINE				8			// 
#define NMFS_STRIKEOUT				16			// 

// UI Service
enum UIServiceOpeType{
	NMUI_GETCAPTION,		// j[ڎ擾
	NMUI_ONCLICK,			// j[ڑI
};

// nh̎
enum NsmHandleType{
	NMHT_CONNECTION,
	NMHT_SESSION,
	NMHT_FILESESSION
};

// G[R[h
#define NMP_NOTIMPLEMENT_ERROR		-1			// ĂȂ
#define NMP_ALLRIGHT				0			// I
#define NMP_INTERNAL_ERROR			100			// G[
#define NMP_UNINITIALIZED_ERROR		101			// vOCĂȂ


// ֐̒` ------------------------------------------------------------------

typedef int (__stdcall *TNsmServiceProc)(WPARAM wParam, LPARAM lParam);
typedef int (__stdcall *TNsmEventProc)(WPARAM wParam, LPARAM lParam);

// {R[obN֐Q
typedef HNsmService (__stdcall *TCreateServiceProc)(LPCTSTR ServiceName, TNsmServiceProc ProcAddr);
typedef HNsmService (__stdcall *TGetServiceProc)(LPCTSTR ServiceName);
typedef int (__stdcall *TCallServiceProc)(HNsmService ServiceHandle, WPARAM wParam, LPARAM lParam);
typedef HNsmEvent (__stdcall *TCreateEventProc)(LPCTSTR EventName);
typedef HNsmEvent (__stdcall *TGetEventProc)(LPCTSTR EventName);
typedef int (__stdcall *TNotifyEventProc)(HNsmEvent EventHandle, WPARAM wParam, LPARAM lParam);
typedef int (__stdcall *THookEventProc)(LPCTSTR EventName, TNsmEventProc ProcAddr);
typedef int (__stdcall *TUnhookEventProc)(LPCTSTR EventName, TNsmEventProc ProcAddr);

// ̑̃R[obN֐
typedef int (__stdcall *TEnumConnectionCallback)(HNsmConnection hConnection, int nData);
typedef int (__stdcall *TEnumSessionCallback)(HNsmSession hSession, int nData);
typedef int (__stdcall *TEnumFileSessionCallback)(HNsmFileSession hSession, int nData);
typedef int (__stdcall *TEnumProtocolCallback)(LPCTSTR lpProtocol, int nData);
typedef int (__stdcall *TEnumModuleCallback)(LPCTSTR lpModuleName, int nData);
typedef int (__stdcall *TEnumMemberCallback)(LPCTSTR lpAccount, int nData);
typedef int (__stdcall *TEnumGroupCallback)(int nGroupID, int nData);
typedef int (__stdcall *TEnumUIServiceCallback)(LPCTSTR lpServiceName, int nData);
typedef void (__stdcall *TNotifyClickCallback)(int nData);

// \̂̐錾 ----------------------------------------------------------------
#pragma pack(push, 1)

// Initialize ֐œn̍\
typedef struct tagTNsmPluginInitInfo{
	int cbSize;
	TCreateServiceProc CreateService;
	TGetServiceProc GetService;
	TCallServiceProc CallService;
	TCreateEventProc CreateEvent;
	TGetEventProc GetEvent;
	TNotifyEventProc NotifyEvent;
	THookEventProc HookEvent;
	TUnhookEventProc UnhookEvent;
} TNsmPluginInitInfo, *PNsmPluginInitInfo;

// vOC
typedef struct tagTNsmPluginInfo{
	int cbSize;								// \̂̃TCY
	LPCTSTR lpModuleName;					// W[
	PluginInfoType nInfoNo;					// 擾ԍ
	LPTSTR lpBuffer;						// i[obt@
	int nBufferSize;						// obt@̑傫
} TNsmPluginInfo, *PNsmPluginInfo;

// OC
typedef struct tagTLogInInfo{
	int cbSize;								// \̂̃TCY
	LPCTSTR lpAccount;						// AJEg
	LPCTSTR lpPassword;						// pX[h
	int nStatus;							// [Ȕ
//	LPCWSTR lpCaption;						// ڑ̃LvV
} TLoginInfo, *PLoginInfo;

// o
typedef struct tagTEnumMemberInfo{
	int cbSize;								// \̂̃TCY
	int nListKind;							// R^NgXg̎
	int nFlags;								// \
	TEnumMemberCallback lpCallBackProc;		// R[obN֐
	int nData;								// R[obN֐ɓnCӃf[^
} TEnumMemberInfo, *PEnumMemberInfo;

// O[v
typedef struct tagTEnumGroupInfo{
	int cbSize;								// \̂̃TCY
	int nFlags;								// \
	TEnumGroupCallback lpCallBackProc;		// R[obN֐
	int nData;								// R[obN֐ɓnCӃf[^
} TEnumGroupInfo, *PEnumGroupInfo;

// 
typedef struct tagTNsmInfo{
	TypeOfValue nType;						// ̌^
	LPBYTE lpBuffer;						// i[obt@
	size_t nBufferSize;						// obt@̃TCY
} TNsmInfo, *PNsmInfo;

// o擾
typedef struct tagTNsmMemberInfo{
	int cbSize;								// \̂̃TCY
	ContactListType nListKind;				// R^NgXg̎
	LPCTSTR lpAccount;						// ݒ|擾õAJEg
	MemberInfoType nInfoKey;				// 擾̃L[
	PNsmInfo lpInfo;						// i[\̂ւ̃|C^
	int nFlags;								// \
} TNsmMemberInfo, *PNsmMemberInfo;

// O[v
typedef struct tagTNsmGroupInfo{
	int cbSize;								// \̂̃TCY
	int nGroupID;							// ݒ|擾O[vID
	GroupInfoType nInfoKey;					// 擾̃L[
	PNsmInfo lpInfo;						// i[\̂ւ̃|C^
	int nFlags;								// \
} TNsmGroupInfo, *PNsmGroupInfo;

// oǉE폜
typedef struct tagTAddMemberInfo{
	int cbSize;								// 
	ContactListType nListKind;				// 
	LPCTSTR lpAccount;						// 
} TAddMemberInfo, *PAddMemberInfo, TRemoveMemberInfo, *PRemoveMemberInfo;

// RlNV
typedef struct tagTNsmConnectionInfo{
	int cbSize;								// \̂̃TCY
	ConnectionInfoType nInfoKey;			// 擾̃L[
	PNsmInfo lpInfo;						// i[\̂ւ̃|C^
} TNsmConnectionInfo, *PNsmConnectionInfo;

// ZbV
typedef struct tagTNsmSessionInfo{
	int cbSize;								// \̂̃TCY
	SessionInfoType nInfoKey;				// 擾̃L[
	PNsmInfo lpInfo;						// i[\̂ւ̃|C^
} TNsmSessionInfo, *PNsmSessionInfo;

// t@CZbV
typedef struct tagTNsmFileSessionInfo{
	int cbSize;								// \̂̃TCY
	FileSessionInfoType nInfoKey;			// 擾̃L[
	PNsmInfo lpInfo;						// i[\̂ւ̃|C^
} TNsmFileSessionInfo, *PNsmFileSessionInfo;

// bZ[W{bNX
typedef struct tagTMessageBoxInfo{
	int cbSize;								// \̂̃TCY
	HWND hWnd;								// eEBhẼnhi0 ̏ꍇ͎ݒj
	LPCWSTR lpText;							//
	LPCWSTR lpCaption;						//
	DWORD uType;							//
} TMessageBoxInfo, *PMessageBoxInfo;

// ʒm
typedef struct tagTNotifyInfo{
	int cbSize;								// \̂̃TCY
	LPCWSTR lpText;							// \镶
	int nTimeToLive;						// L\ԁibA0=ƕ\A-1=ftHglj
	NotifyIconType nIcon;					// \ACR̎
	LPCWSTR lpLinkTo;						// NbNƂɊJURL
	TNotifyClickCallback lpOnClick;			// NbNƂɌĂ΂R[obN֐
	int nData;								// R[obN֐ɓnCӃf[^
} TNotifyInfo, *PNotifyInfo;

// ZbVI[v
typedef struct tagTOpenSessionInfo{
	int cbSize;								// \̂̃TCY
	LPCTSTR lpToAccount;					// 
} TOpenSessionInfo, *POpenSessionInfo;

// t@CZbVI[v
typedef struct tagTOpenFileSessionInfo{
	int cbSize;								// \̂̃TCY
	LPCTSTR lpFileName;						// t@C
	LPCTSTR lpFileDir;						// t@ĈfBNg
} TOpenFileSessionInfo, *POpenFileSessionInfo;

// 񑮐
typedef struct tagTTextAttributeInfo{
	int cbSize;								// \̂̃TCY
	LPCWSTR lpFontName;						// tHg
	int nCharSet;							// LN^ZbgiShiftJIS = 128j
	int nFontSize;							// TCYi|Cgj
	int nFontColor;							// F
	int nBgColor;							// wiF
	int nStyles;							// tOiBold, Italic, etc...j
} TTextAttributeInfo, *PTextAttributeInfo;

// bZ[W
typedef struct tagTMessageInfo{
	int cbSize;								// \̂̃TCY
	LPCTSTR lpFrom;							// olAJEgiM̏ꍇ NULL łj
	LPCWSTR lpBody;							// bZ[W̖{iUNICODEj
	PTextAttributeInfo lpTextAttribute;		// 
	int nFlags;								// \
} TMessageInfo, *PMessageInfo;

// [UXe[^X
typedef struct tagTUserStatusInfo{
	int cbSize;								// \̂̃TCY
	MemberStatus nStatus;					// 
	LPCWSTR lpStatusStr;					// Ԃ\iNMST_CUSTOM ̎̂ݗLj
	int nBusyness;							// ZiNMST_CUSTOM ̎̂ݗLj
} TUserStatusInfo, *PUserStatusInfo;

// [U
typedef struct tagTUserNameInfo{
	int cbSize;								// \̂̃TCY
	LPCWSTR lpName;							// VO
} TUserNameInfo, *PUserNameInfo;

// O[v
typedef struct tagTGroupNameInfo{
	int cbSize;
	int nGroupId;
	LPCWSTR lpName;
} TGroupNameInfo, *PGroupNameInfo;

// oO[v
typedef struct tagTMemberGroupInfo{
	int cbSize;
	LPCTSTR lpAccount;
	int nGroupId;
} TMemberGroupInfo, *PMemberGroupInfo;

// UIT[rX
typedef struct tagTEnumUIServiceInfo{
	int cbSize;								// \̂̃TCY
	TEnumUIServiceCallback lpCallBackProc;	// R[obN֐ւ̃|C^
	int nData;								// R[obN֐ɓnf[^
	int nFlags;								// \
} TEnumUIServiceInfo, *PEnumUIServiceInfo;

// UIT[rXĂяo
typedef struct tagTNsmUIServiceInfo{
	int cbSize;								// \̂̃TCY
	UIServiceOpeType nInfoKey;				// UIT[rXĂяoR
	int nGroupId;							// O[vIDiMemberAGroup̂ݗLj
	LPCTSTR lpAccount;						// AJEgiMember̂ݗLj
	PNsmInfo lpInfo;						// ݒp
	int nFlags;								// \
} TNsmUIServiceInfo, *PNsmUIServiceInfo;

// ʐMO
typedef struct tagTNsmComLogInfo {
	int cbSize;								// \̃TCY
	NsmHandleType nType;					// nh̎
	HNsmHandle lpHandle;					// nh
	LPCSTR lpHeader;						// wb_
	LPCSTR lpMessage;						// bZ[W{
} TNsmComLogInfo, *PNsmComLogInfo;

#pragma pack(pop)

// 萔̐錾 ------------------------------------------------------------------

// W[
#define NMM_SYSTEM							"System"
#define NMM_PROTOCOL						"Protocol"
#define NMM_UI								"UI"
#define NMM_ADDIN							"AddIn"

// T[rXECxg̃JeS
#define NMD_SYSTEM_CONNECTION							NMM_SYSTEM"/Connection"
#define NMD_SYSTEM_CONNECTION_MEMBERS					NMD_SYSTEM_CONNECTION"/Members"
#define NMD_SYSTEM_CONNECTION_GROUPS					NMD_SYSTEM_CONNECTION"/Groups"

#define NMD_SYSTEM_CONNECTION_UISERVICE					NMD_SYSTEM_CONNECTION "/UIService"
#define NMD_SYSTEM_CONNECTION_UISERVICE_MEMBER			NMD_SYSTEM_CONNECTION_UISERVICE "/Member"
#define NMD_SYSTEM_CONNECTION_UISERVICE_GROUP			NMD_SYSTEM_CONNECTION_UISERVICE "/Group"

#define NMD_SYSTEM_SESSION								NMM_SYSTEM"/Session"
#define NMD_SYSTEM_SESSION_MEMBERS						NMD_SYSTEM_SESSION"/Members"

#define NMD_SYSTEM_FILESESSION							NMM_SYSTEM "/FileSession"
  
#define NMD_SYSTEM_ADDIN								NMM_SYSTEM "/AddIn"
#define NMD_SYSTEM_ADDIN_UISERVICE						NMD_SYSTEM_ADDIN "/UIService"
#define NMD_SYSTEM_ADDIN_UISERVICE_MAIN					NMD_SYSTEM_ADDIN_UISERVICE "/Main"
#define NMD_SYSTEM_ADDIN_UISERVICE_MEMBER				NMD_SYSTEM_ADDIN_UISERVICE "/Member"
#define NMD_SYSTEM_ADDIN_UISERVICE_GROUP				NMD_SYSTEM_ADDIN_UISERVICE "/Group"
#define NMD_SYSTEM_ADDIN_UISERVICE_TAB					NMD_SYSTEM_ADDIN_UISERVICE "/Tab"

#define NMD_PROTOCOL									NMM_PROTOCOL "/%s"

#define NMD_PROTOCOL_CONNECTION							NMM_PROTOCOL "/%s/Connection"
#define NMD_PROTOCOL_CONNECTION_UISERVICE				NMD_PROTOCOL_CONNECTION "/UIService"
#define NMD_PROTOCOL_CONNECTION_UISERVICE_MEMBER		NMD_PROTOCOL_CONNECTION_UISERVICE "/Member"
#define NMD_PROTOCOL_CONNECTION_UISERVICE_GROUP			NMD_PROTOCOL_CONNECTION_UISERVICE "/Group"

#define NMD_PROTOCOL_SESSION							NMM_PROTOCOL "/%s/Session"
#define NMD_PROTOCOL_FILESESSION						NMM_PROTOCOL "/%s/FileSession"

#define NMD_ADDIN_UISERVICE								NMM_ADDIN "/%s/UIService"
#define NMD_ADDIN_UISERVICE_MAIN						NMD_ADDIN_UISERVICE "/Main"
#define NMD_ADDIN_UISERVICE_MEMBER						NMD_ADDIN_UISERVICE "/Member"
#define NMD_ADDIN_UISERVICE_GROUP						NMD_ADDIN_UISERVICE "/Group"
#define NMD_ADDIN_UISERVICE_TAB							NMD_ADDIN_UISERVICE "/Tab"

// W[ʃT[rX
#define NMS_COMMON_SHOWOPTIONDIALOG						PLUGIN_MODULENAME "/ShowOptionDialog"

// System Event
#define NME_SYSTEM_MODULESLOADED						NMM_SYSTEM "/OnModulesLoaded"

#define NME_SYSTEM_CONNECTION_CONNECT					NMD_SYSTEM_CONNECTION"/OnConnect"
#define NME_SYSTEM_CONNECTION_DISCONNECT				NMD_SYSTEM_CONNECTION"/OnDisconnect"
#define NME_SYSTEM_CONNECTION_INFOCHANGE				NMD_SYSTEM_CONNECTION"/OnInfoChange"
#define NME_SYSTEM_CONNECTION_MEMBERS_ADD				NMD_SYSTEM_CONNECTION_MEMBERS"/OnAdd"
#define NME_SYSTEM_CONNECTION_MEMBERS_REMOVE			NMD_SYSTEM_CONNECTION_MEMBERS"/OnRemove"
#define NME_SYSTEM_CONNECTION_MEMBERS_INFOCHANGE		NMD_SYSTEM_CONNECTION_MEMBERS"/OnInfoChange"
#define NME_SYSTEM_CONNECTION_MEMBERS_INFOCHANGING		NMD_SYSTEM_CONNECTION_MEMBERS"/OnInfoChanging"
#define NME_SYSTEM_CONNECTION_GROUPS_ADD				NMD_SYSTEM_CONNECTION_GROUPS"/OnAdd"
#define NME_SYSTEM_CONNECTION_GROUPS_REMOVE				NMD_SYSTEM_CONNECTION_GROUPS"/OnRemove"
#define NME_SYSTEM_CONNECTION_GROUPS_INFOCHANGE			NMD_SYSTEM_CONNECTION_GROUPS"/OnInfoChange"

#define NME_SYSTEM_SESSION_OPEN							NMD_SYSTEM_SESSION"/OnOpen"
#define NME_SYSTEM_SESSION_CLOSE						NMD_SYSTEM_SESSION"/OnClose"
#define NME_SYSTEM_SESSION_INFOCHANGE					NMD_SYSTEM_SESSION"/OnInfoChange"
#define NME_SYSTEM_SESSION_MEMBERS_ADD					NMD_SYSTEM_SESSION_MEMBERS"/OnAdd"
#define NME_SYSTEM_SESSION_MEMBERS_REMOVE				NMD_SYSTEM_SESSION_MEMBERS"/OnRemove"
#define NME_SYSTEM_SESSION_MEMBERS_INFOCHANGE			NMD_SYSTEM_SESSION_MEMBERS"/OnInfoChange"

#define NME_SYSTEM_SESSION_SENDMESSAGE					NMD_SYSTEM_SESSION"/OnSendMessage"
#define NME_SYSTEM_SESSION_RECEIVEMESSAGE				NMD_SYSTEM_SESSION"/OnReceiveMessage"

#define NME_SYSTEM_FILESESSION_OPEN						NMD_SYSTEM_FILESESSION "/OnOpen"
#define NME_SYSTEM_FILESESSION_CLOSE					NMD_SYSTEM_FILESESSION "/OnClose"
#define NME_SYSTEM_FILESESSION_INFOCHANGE				NMD_SYSTEM_FILESESSION "/OnInfoChange"

// System Service
#define NMS_SYSTEM_EXIT									NMM_SYSTEM"/Exit"
#define NMS_SYSTEM_DEBUG_PRINT							NMM_SYSTEM"/Debug/Print"
#define NMS_SYSTEM_ENUMPROTOCOLS						NMM_SYSTEM"/EnumProtocols"
#define NMS_SYSTEM_ENUMMODULES							NMM_SYSTEM"/EnumModules"
#define NMS_SYSTEM_GETPLUGININFO						NMM_SYSTEM"/GetPluginInfo"

#define NMS_SYSTEM_CONNECTION_CREATE					NMD_SYSTEM_CONNECTION"/Create"
#define NMS_SYSTEM_CONNECTION_DELETE					NMD_SYSTEM_CONNECTION"/Delete"
#define NMS_SYSTEM_CONNECTION_GETINFO					NMD_SYSTEM_CONNECTION"/GetInfo"
#define NMS_SYSTEM_CONNECTION_SETINFO					NMD_SYSTEM_CONNECTION"/SetInfo"
#define NMS_SYSTEM_CONNECTION_ENUM						NMD_SYSTEM_CONNECTION"/Enum"

#define NMS_SYSTEM_CONNECTION_MEMBERS_ADD				NMD_SYSTEM_CONNECTION_MEMBERS"/Add"
#define NMS_SYSTEM_CONNECTION_MEMBERS_REMOVE			NMD_SYSTEM_CONNECTION_MEMBERS"/Remove"
#define NMS_SYSTEM_CONNECTION_MEMBERS_GETINFO			NMD_SYSTEM_CONNECTION_MEMBERS"/GetInfo"
#define NMS_SYSTEM_CONNECTION_MEMBERS_SETINFO			NMD_SYSTEM_CONNECTION_MEMBERS"/SetInfo"
#define NMS_SYSTEM_CONNECTION_MEMBERS_ENUM				NMD_SYSTEM_CONNECTION_MEMBERS"/Enum"
#define NMS_SYSTEM_CONNECTION_MEMBERS_BEGINUPDATE		NMD_SYSTEM_CONNECTION_MEMBERS"/BeginUpdate"
#define NMS_SYSTEM_CONNECTION_MEMBERS_ENDUPDATE			NMD_SYSTEM_CONNECTION_MEMBERS"/EndUpdate"

#define NMS_SYSTEM_CONNECTION_GROUPS_ADD				NMD_SYSTEM_CONNECTION_GROUPS"/Add"
#define NMS_SYSTEM_CONNECTION_GROUPS_REMOVE				NMD_SYSTEM_CONNECTION_GROUPS"/Remove"
#define NMS_SYSTEM_CONNECTION_GROUPS_GETINFO			NMD_SYSTEM_CONNECTION_GROUPS"/GetInfo"
#define NMS_SYSTEM_CONNECTION_GROUPS_SETINFO			NMD_SYSTEM_CONNECTION_GROUPS"/SetInfo"
#define NMS_SYSTEM_CONNECTION_GROUPS_ENUM				NMD_SYSTEM_CONNECTION_GROUPS"/Enum"
#define NMS_SYSTEM_CONNECTION_GROUPS_BEGINUPDATE		NMD_SYSTEM_CONNECTION_GROUPS"/BeginUpdate"
#define NMS_SYSTEM_CONNECTION_GROUPS_ENDUPDATE			NMD_SYSTEM_CONNECTION_GROUPS"/EndUpdate"

#define NMS_SYSTEM_SESSION_CREATE						NMD_SYSTEM_SESSION"/Create"
#define NMS_SYSTEM_SESSION_DELETE						NMD_SYSTEM_SESSION"/Delete"
#define NMS_SYSTEM_SESSION_GETINFO						NMD_SYSTEM_SESSION"/GetInfo"
#define NMS_SYSTEM_SESSION_SETINFO						NMD_SYSTEM_SESSION"/SetInfo"
#define NMS_SYSTEM_SESSION_ENUM							NMD_SYSTEM_SESSION"/Enum"

#define NMS_SYSTEM_SESSION_MEMBERS_ADD					NMD_SYSTEM_SESSION_MEMBERS"/Add"
#define NMS_SYSTEM_SESSION_MEMBERS_REMOVE				NMD_SYSTEM_SESSION_MEMBERS"/Remove"
#define NMS_SYSTEM_SESSION_MEMBERS_GETINFO				NMD_SYSTEM_SESSION_MEMBERS"/GetInfo"
#define NMS_SYSTEM_SESSION_MEMBERS_SETINFO				NMD_SYSTEM_SESSION_MEMBERS"/SetInfo"
#define NMS_SYSTEM_SESSION_MEMBERS_ENUM					NMD_SYSTEM_SESSION_MEMBERS"/Enum"
#define NMS_SYSTEM_SESSION_MEMBERS_BEGINUPDATE			NMD_SYSTEM_SESSION_MEMBERS"/BeginUpdate"
#define NMS_SYSTEM_SESSION_MEMBERS_ENDUPDATE			NMD_SYSTEM_SESSION_MEMBERS"/EndUpdate"

#define NMS_SYSTEM_SESSION_SENDMESSAGE					NMD_SYSTEM_SESSION"/SendMessage"
#define NMS_SYSTEM_SESSION_RECEIVEMESSAGE				NMD_SYSTEM_SESSION"/ReceiveMessage"

#define NMS_SYSTEM_FILESESSION_CREATE					NMD_SYSTEM_FILESESSION "/Create"
#define NMS_SYSTEM_FILESESSION_DELETE					NMD_SYSTEM_FILESESSION "/Delete"
#define NMS_SYSTEM_FILESESSION_GETINFO					NMD_SYSTEM_FILESESSION "/GetInfo"
#define NMS_SYSTEM_FILESESSION_SETINFO					NMD_SYSTEM_FILESESSION "/SetInfo"
#define NMS_SYSTEM_FILESESSION_ENUM						NMD_SYSTEM_FILESESSION "/Enum"
  
#define NMS_SYSTEM_CONNECTION_UISERVICE_MEMBER_ENUM		NMD_SYSTEM_CONNECTION_UISERVICE_MEMBER "/Enum"
#define NMS_SYSTEM_CONNECTION_UISERVICE_GROUP_ENUM		NMD_SYSTEM_CONNECTION_UISERVICE_GROUP "/Enum"

#define NMS_SYSTEM_ADDIN_UISERVICE_MAIN_ENUM			NMD_SYSTEM_ADDIN_UISERVICE_MAIN "/Enum"
#define NMS_SYSTEM_ADDIN_UISERVICE_MEMBER_ENUM			NMD_SYSTEM_ADDIN_UISERVICE_MEMBER "/Enum"
#define NMS_SYSTEM_ADDIN_UISERVICE_GROUP_ENUM			NMD_SYSTEM_ADDIN_UISERVICE_GROUP "/Enum"
#define NMS_SYSTEM_ADDIN_UISERVICE_TAB_ENUM				NMD_SYSTEM_ADDIN_UISERVICE_TAB "/Enum"

// Protocol Event
#define NME_PROTOCOL_LOG								NMD_PROTOCOL "/OnLog"

// Protocol Service
#define NMS_PROTOCOL_CONNECTION_CONNECT					NMD_PROTOCOL_CONNECTION "/Connect"
#define NMS_PROTOCOL_CONNECTION_DISCONNECT				NMD_PROTOCOL_CONNECTION "/Disconnect"
#define NMS_PROTOCOL_CONNECTION_CHANGEUSERSTATUS		NMD_PROTOCOL_CONNECTION "/ChangeUserStatus"
#define NMS_PROTOCOL_CONNECTION_CHANGEUSERNAME			NMD_PROTOCOL_CONNECTION "/ChangeUserName"
#define NMS_PROTOCOL_CONNECTION_ADDMEMBER				NMD_PROTOCOL_CONNECTION "/AddMember"
#define NMS_PROTOCOL_CONNECTION_REMOVEMEMBER			NMD_PROTOCOL_CONNECTION "/RemoveMember"
#define NMS_PROTOCOL_CONNECTION_CHANGEMEMBERGROUP		NMD_PROTOCOL_CONNECTION "/ChangeMmeberGroup"
#define NMS_PROTOCOL_CONNECTION_ADDGROUP				NMD_PROTOCOL_CONNECTION "/AddGroup"
#define NMS_PROTOCOL_CONNECTION_REMOVEGROUP				NMD_PROTOCOL_CONNECTION "/RemoveGroup"
#define NMS_PROTOCOL_CONNECTION_CHANGEGROUPNAME			NMD_PROTOCOL_CONNECTION "/ChangeGroupName"
#define NMS_PROTOCOL_CONNECTION_OPENMAIL				NMD_PROTOCOL_CONNECTION "/OpenMail"

#define NMS_PROTOCOL_SESSION_OPEN						NMD_PROTOCOL_SESSION"/Open"
#define NMS_PROTOCOL_SESSION_CLOSE						NMD_PROTOCOL_SESSION"/Close"
#define NMS_PROTOCOL_SESSION_INVITEMEMBER				NMD_PROTOCOL_SESSION"/InviteMember"
#define NMS_PROTOCOL_SESSION_SENDMESSAGE				NMD_PROTOCOL_SESSION"/SendMessage"
#define NMS_PROTOCOL_SESSION_BEGINTYPING				NMD_PROTOCOL_SESSION "/BeginTyping"
#define NMS_PROTOCOL_SESSION_ENDTYPING					NMD_PROTOCOL_SESSION "/EndTyping"
  
#define NMS_PROTOCOL_FILESESSION_OPEN					NMD_PROTOCOL_FILESESSION "/Open"
#define NMS_PROTOCOL_FILESESSION_ACCEPT					NMD_PROTOCOL_FILESESSION "/Accept"
#define NMS_PROTOCOL_FILESESSION_CANCEL					NMD_PROTOCOL_FILESESSION "/Cancel"
#define NMS_PROTOCOL_FILESESSION_CLOSE					NMD_PROTOCOL_FILESESSION "/Close"
  
#define NMS_PROTOCOL_CONNECTION_UISERVICE_MEMBER		NMD_PROTOCOL_CONNECTION_UISERVICE_MEMBER "/%s"
#define NMS_PROTOCOL_CONNECTION_UISERVICE_GROUP			NMD_PROTOCOL_CONNECTION_UISERVICE_GROUP "/%s"

// UI Service
#define NMS_UI_NOTIFY									NMM_UI"/Notify"
#define NMS_UI_MESSAGEBOX								NMM_UI"/MessageBox"

// Addin Service
#define NMS_ADDIN_UISERVICE_MAIN						NMD_ADDIN_UISERVICE_MAIN "/%s"
#define NMS_ADDIN_UISERVICE_MEMBER						NMD_ADDIN_UISERVICE_MEMBER "/%s"
#define NMS_ADDIN_UISERVICE_GROUP						NMD_ADDIN_UISERVICE_GROUP "/%s"
#define NMS_ADDIN_UISERVICE_TAB						NMD_ADDIN_UISERVICE_TAB "/%s"

#endif			/* NSM_PLUGIN_H */
