#include "stdafx.h"
#include "util.h"

// w肳ꂽpXɊ܂܂SẴfBNg
// ԍṒu\vȍ~̓t@CƂ݂Ȃ
int CreateDirAll(LPCTSTR lpPath)
{
	TCHAR buf[MAX_PATH];
	LPTSTR pos;
	DWORD ret;
	BOOL bSucsess;

	_tcsncpy_s(buf, lpPath, sizeof(buf));

	pos = buf;
	for(;;){
		pos = _tcschr(pos, '\\');
		if( pos == NULL ) break;

		*pos = '\0';
		ret = GetFileAttributes(buf);

		// 擾s
		if( ret == -1 )
		{
			ret = GetLastError();
			// pXȂfBNg쐬
			if( ret == ERROR_FILE_NOT_FOUND ){
				bSucsess = CreateDirectory(buf, NULL);
				if( !bSucsess ) return CDA_CANT_MAKE_DIR;
			}else{
				return CDA_CANT_GET_ATTR;
			}
		}
		else
		{
			// fBNgł͂Ȃs
			if( !(ret & FILE_ATTRIBUTE_DIRECTORY) ){
				return CDA_NOT_DIR;
			}
		}
		*pos++ = '\\';
	}
	return CDA_OK;
}

LPTSTR DuplicateString(LPCTSTR str)
{
	LPTSTR dup;

	dup = new TCHAR[lstrlen(str)+1];
	lstrcpy(dup, str);

	return dup;
}

void EscapeForHTML(std::wstring &out, LPCWSTR in)
{
	out.clear();
	out.reserve(wcslen(in));
	for( LPCWSTR src = in; *src != L'\0'; src++ ){
		switch( *src ){
		case L'<': out += L"&lt;"; break;
		case L'>': out += L"&gt;"; break;
		case L'&': out += L"&amp;"; break;
		case L'"': out += L"&quot;"; break;
		case L'\'': out += L"&#39;"; break;
		case L'\r': out += L"<br/>\r"; break;
		default: out += *src; break;
		}
	}
}

void EscapeForHTML(std::string &out, LPCSTR in)
{
	out.clear();
	out.reserve(strlen(in));
	for( LPCSTR src = in; *src != L'\0'; src++ ){
		switch( *src ){
		case '<': out += "&lt;"; break;
		case '>': out += "&gt;"; break;
		case '&': out += "&amp;"; break;
		case '"': out += "&quot;"; break;
		case '\'': out += "&#39;"; break;
		case '\r': out += "<br/>\r"; break;
		default: out += *src; break;
		}
	}
}

#define NULL2	((LPCWSTR)-1)
void LinkURL(std::wstring &out, LPCWSTR in)
{
	LPCWSTR st, ed, pos;
	LPCWSTR http, ftp;

	http = wcsstr(in, L"http");
	if( http == NULL ) http = NULL2;
	ftp = wcsstr(in, L"ftp://");
	if( ftp == NULL ) ftp = NULL2;

	ed = in;
	while( http != NULL2 || ftp != NULL2 ){
		if( http < ftp ){
			if( wcsncmp(http + 4, L"://", 3) == 0 ){
				pos = http + 7;
			}else if( wcsncmp(http + 4, L"s://", 4) == 0 ){
				pos = http + 8;
			}else{
				http = wcsstr(http+4, L"http");
				if( http == NULL ) http = NULL2;
				continue;
			}
			st = http;

		}else{
			st = ftp;
			pos = ftp + 6;

		}
		out.append(ed, st - ed);

		while( L'!' <= *pos && *pos <= L'~' && *pos != L'<' && *pos != L'>' ) pos++;
		ed = pos;

		out += L"<a href='";
		out.append(st, ed - st);
		out += L"' target='_blank'>";
		out.append(st, ed - st);
		out += L"</a>";

		if( http < ftp ){
			http = wcsstr(ed, L"http");
			if( http == NULL ) http = NULL2;
		}else{
			ftp = wcsstr(ed, L"ftp://");
			if( ftp == NULL ) ftp = NULL2;
		}
	}
	out += ed;
}


void FilePathFromFilePath(LPSTR buf, LPCSTR fromPath, LPCSTR file)
{
	LPSTR pos;

	strcpy_s(buf, MAX_PATH, fromPath);
	pos = strrchr(buf,'\\');
	if( pos != NULL ) *(pos+1) = '\0';
	strcat_s(buf, MAX_PATH, file);
}
bool FileExists(LPCSTR path)
{
	HANDLE hFind;
	WIN32_FIND_DATA fdata;

	hFind = FindFirstFile(path, &fdata);
	if( hFind != INVALID_HANDLE_VALUE ){
		FindClose(hFind);
		return (fdata.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0;
	}else{
		return false;
	}
}

BOOL Rename(LPCSTR lpOld, LPCSTR lpNew)
{
	BOOL ret;

	ret = DeleteFile(lpNew);
	if( !ret && ::GetLastError() != ERROR_FILE_NOT_FOUND )
		return FALSE;

	ret = MoveFile(lpOld, lpNew);
	return ret;
}

#define BASE_CHAR	'@'
void UnicodeToHex(LPCWSTR in, std::string* out)
{
	*out = "";
	out->reserve(wcslen(in) * 4);

	for( ; *in != L'\0'; ++in ){
		*out += (char)(BASE_CHAR + ((*in >> 12) & 0xF));
		*out += (char)(BASE_CHAR + ((*in >> 8) & 0xF));
		*out += (char)(BASE_CHAR + ((*in >> 4) & 0xF));
		*out += (char)(BASE_CHAR + ((*in >> 0) & 0xF));
	}
}

void HexToUnicode(LPCSTR in, std::wstring* out)
{
	wchar_t c;

	*out = L"";
	out->reserve(strlen(in)/4);

	while( *in != '\0' ){
		c = (*in++ - BASE_CHAR) << 12;
		c |= (*in++ - BASE_CHAR) << 8;
		c |= (*in++ - BASE_CHAR) << 4;
		c |= (*in++ - BASE_CHAR) << 0;
		*out += c;
	}
}

