#pragma once


template <class LockT, class LockedItemT=LockT::LockTarget>
class CLock
{
private:
	LockT *m_pLock;
	LockedItemT *m_pItem;

public:
	CLock(LockT &lock)
	{
		m_pLock = &lock;
		m_pItem = &(lock.Lock());
	}
	CLock(LockT *lock)
	{
		m_pLock = lock;
		m_pItem = &(lock->Lock());
	}
	~CLock()
	{
		m_pLock->Unlock();
	}
	LockedItemT* operator ->()
	{
		return m_pItem;
	}
	LockedItemT& operator *()
	{
		return *m_pItem;
	}
};

